<script setup>
import AppShare from '@/helpers/AppShare'
import { useDialogStore } from '@/stores/DialogStore';
import Constants from '@/Constants'
</script>


<script>
export default {

	data() {
		const params = new URLSearchParams(window.location.search)
		const trash = Number(params.get('trash')) ? 1 : 0
		return {
			params,
			page: Number(params.get('page')) ?? 0,
			order: params.get('order') ?? 'id',
			search: params.get('search') ?? '',
			trash,
			trashBin: trash.value ? this.$t('trash_') : this.$t('trash'),
			options: [
				{ value: 'id', text: this.$t('sortBy.id') },
				{ value: 'email', text: this.$t('sortBy.emailAsc') },
				{ value: 'email-', text: this.$t('sortBy.emailDesc') },
				{ value: 'created', text: this.$t('sortBy.signUpAsc') },
				{ value: 'created-', text: this.$t('sortBy.signUpDesc') },
			],
			items: null,
			pagination: null,
		}
	},

	methods: {
		conditionsToUrl() {
			const cond = `page=${this.page}`
				+ `&order=${this.order}`
				+ `&search=${this.search}`
				+ `&trash=${this.trash}`
			return cond
		},

		goToPage(diff) {
			if (diff < 0) {
				if (this.page > 0) {
					this.page--
					this.params.set('page', this.page.toString())
					this.$router.push(`/members?${this.params.toString()}`)
					this.refresh()
				}
			}
			else if (diff > 0) {
				if (this.page < this.pagination.pageCount - 1) {
					this.page++
					this.params.set('page', this.page.toString())
					this.$router.push(`/members?${this.params.toString()}`)
					this.refresh()
				}
			}
		},

		changeOrder(o) {
			this.params.set('order', this.order)
			this.$router.push(`/members?${this.params.toString()}`)
			this.refresh()
		},

		setSearch() {
			this.params.set('search', this.search)
			this.$router.push(`/members?${this.params.toString()}`)
			this.refresh()
		},

		switchTrash() {
			this.trash = !this.trash ? 1 : 0
			this.trashBin = this.trash ? this.$t('trash_') : this.$t('trash')
			this.params.set('trash', this.trash.toString())
			this.$router.push(`/members?${this.params.toString()}`)
			this.refresh()
		},

		async refresh() {
			const dialogStore = useDialogStore()
			const cond = this.conditionsToUrl()
			//const url = `members?size=1&${cond}`
			const url = `members?${cond}`
			const result = await dialogStore.waitBox(async () =>
				await AppShare.client.call(url, {
					method: 'GET',
					headers: AppShare.client.defaultHeaders(),
				})
			)
			if (!dialogStore.handleRestError(result)) {
				this.items = result?.json.members
				this.pagination = result?.json.pagination
			}
		},
	},

	mounted() {
		this.refresh()
	},

	i18n: {
		messages: {
			en: {
				title: "Members",
				sortBy: {
					id: "Id",
					emailAsc: "Email ASC",
					emailDesc: "Email DESC",
					signUpAsc: "Sign Up ASC",
					signUpDesc: "Sign Up DESC"
				},
				trash: "Disabled or Resigned",
				trash_: "Normal",
			},
			th: {
				title: "สมาชิก",
				sortBy: {
					id: "Id",
					emailAsc: "อีเมล น้อยไปมาก",
					emailDesc: "อีเมล มากไปน้อย",
					signUpAsc: "วันที่สมัคร น้อยไปมาก",
					signUpDesc: "วันที่สมัคร มากไปน้อย"
				},
				trash: "ถูกระงับการใช้งาน หรือ ลาออกจากระบบ",
				trash_: "ปกติ",
			},
		},
	},
}
</script>


<template>
	<AuthenRequired>
		<AppBox :title="$t('title')">
			<!-- ordering, searching and trashing -->
			<select v-model="order" @click.prevent="(e) => changeOrder(order)">
				<option v-for="option in options" :value="option.value">
					{{ option.text }}
				</option>
			</select>
			<input v-model="search" @keyup.enter="(e) => setSearch()" />
			<button @click.prevent="(e) => switchTrash()">{{ trashBin }}</button><br />
			<br />

			<!-- data -->
			<div v-for="(item, index) in items" :key="index" class="item">
				<a :href="`/members/${item.email.replace(/\./g, () => '%2E')}`">
					<img :src="`${Constants.baseUrl}/members/${item.email}/icon`">
					<div>
						<span>{{ item.email }}</span>
						<span>{{ item.name }}</span>
					</div>
				</a>
			</div>
			<br />

			<!-- pagination -->
			<div v-if="pagination && pagination.pageCount > 0">
				<button @click.prevent="(e) => goToPage(-1)">&nbsp;&lt;&nbsp;</button>
				<span style="padding: 0 1rem">{{ `${pagination.page + 1} / ${pagination.pageCount}` }}</span>
				<button @click.prevent="(e) => goToPage(1)">&nbsp;&gt;&nbsp;</button>
			</div>
		</AppBox>
	</AuthenRequired>
</template>


<style scoped>
.item a {
	display: block;
}

.item img {
	display: inline-block;
	width: 80px;
	height: 80px;
}

.item div {
	display: inline-block;
	margin: 0 0 0 1rem;
	padding: 0.5rem 0 0 0;
	vertical-align: top;
}

.item div span:nth-child(1) {
	display: block;
	font-size: 120%;
	color: #444;
}

.item div span:nth-child(2) {
	display: block;
	color: #888;
}

@media (prefers-color-scheme: dark) {
	.item div span:nth-child(1) {
		display: block;
		font-size: 120%;
		color: #ccc;
	}
}
</style>
